# Enum ServiceFindMode

java.lang.Object
java.lang.Enum<ServiceFindMode>
uk.ac.starlink.ttools.cone.ServiceFindMode

All Implemented Interfaces:
  `Serializable, Comparable<ServiceFindMode>, java.lang.constant.Constable`

public enum ServiceFindMode extends Enum<ServiceFindMode>
Enumeration of ways to submit an upload match to a service.

Since:
  17 May 2014
Author:
  Mark Taylor

## Nested Class Summary

### Nested classes/interfaces inherited from class Enum

`Enum.EnumDesc<E>`

## Enum Constant Summary

Enum Constants
Enum Constant
Description
`ALL`
All matches.
`ALL_SCORE`
All matches, score column only.
`BEST`
Best remote match only for each input row.
`BEST_REMOTE`
Best input match only for each remote row.
`BEST_SCORE`
Best remote match only for each input row, score column only.

## Method Summary

Modifier and Type
Method
Description
`boolean`
`isBestOnly()`
Indicates whether only the rows with the best match to an input row are returned, or all matches.
`boolean`
`isRemoteUnique()`
Indicates whether the nature of this match requires that each row from the remote table may appear at most once in the result.
`boolean`
`isScoreOnly()`
Indicates whether the output columns will contain just the score, or (at least some) columns from the remote table.
`boolean`
`supportsOneToOne()`
Indicates whether this mode will allow use in a context where there is exactly one output row for each input row.
`static ServiceFindMode`
`valueOf(String name)`
Returns the enum constant of this type with the specified name.
`static ServiceFindMode[]`
`values()`
Returns an array containing the constants of this enum type, in the order they are declared.

### Methods inherited from class Enum

`clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods inherited from class Object

`getClass, notify, notifyAll, wait, wait, wait`

## Enum Constant Details

### ALL

public static final ServiceFindMode ALL
All matches.

### BEST

public static final ServiceFindMode BEST
Best remote match only for each input row.

### BEST_REMOTE

public static final ServiceFindMode BEST_REMOTE
Best input match only for each remote row.

### ALL_SCORE

public static final ServiceFindMode ALL_SCORE
All matches, score column only.

### BEST_SCORE

public static final ServiceFindMode BEST_SCORE
Best remote match only for each input row, score column only.

## Method Details

### values

public static ServiceFindMode[] values()
Returns an array containing the constants of this enum type, in the order they are declared.

Returns:
  an array containing the constants of this enum type, in the order they are declared

### valueOf

public static ServiceFindMode valueOf(String name)
Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `IllegalArgumentException` - if this enum type has no constant with the specified name
  `NullPointerException` - if the argument is null

### isBestOnly

public boolean isBestOnly()
Indicates whether only the rows with the best match to an input row are returned, or all matches.

Returns:
  true for best match only, false for all matches

### isScoreOnly

public boolean isScoreOnly()
Indicates whether the output columns will contain just the score, or (at least some) columns from the remote table.

Returns:
  true iff only the match score column is returned

### isRemoteUnique

public boolean isRemoteUnique()
Indicates whether the nature of this match requires that each row from the remote table may appear at most once in the result.

If performing the upload match in blocks, a true result from this method may mean that some post-processing of the result needs to be done.

Returns:
  true iff remote rows must appear <=1 time in result

### supportsOneToOne

public boolean supportsOneToOne()
Indicates whether this mode will allow use in a context where there is exactly one output row for each input row.

Returns:
  true iff 1:1 input/output row usage is supported